import java.io.BufferedReader;
import java.io.FileWriter;
import java.io.InputStreamReader;
import java.net.MalformedURLException;
import java.net.URL;

import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.ui.forms.widgets.FormToolkit;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.browser.AuthenticationEvent;
import org.eclipse.swt.browser.AuthenticationListener;
import org.eclipse.swt.browser.Browser;
import org.eclipse.swt.browser.LocationEvent;
import org.eclipse.swt.browser.LocationListener;
import org.eclipse.swt.browser.ProgressEvent;
import org.eclipse.swt.browser.ProgressListener;
import org.eclipse.swt.browser.VisibilityWindowListener;
import org.eclipse.swt.browser.WindowEvent;
import org.eclipse.swt.events.KeyEvent;
import org.eclipse.swt.events.KeyListener;


public class BrowserSWT extends Shell {
	//	private final FormToolkit formToolkit = new FormToolkit(Display.getDefault());

	private boolean login = false;
	private boolean doIt = false;
	String email, pass;
	AppCrawler crawler = new AppCrawler();
	/**
	 * Launch the application.
	 * @param args
	 */
	public static void main(String args[]) {
		try {
			System.out.println("Starting");
			Display display = Display.getDefault();
			BrowserSWT shell = new BrowserSWT(display);
			shell.open();
			shell.layout();
			while (!shell.isDisposed()) {
				if (!display.readAndDispatch()) {
					display.sleep();
				}
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	Browser browser;

	/**
	 * Create the shell.
	 * @param display
	 */
	public BrowserSWT(Display display) {
		super(display, SWT.SHELL_TRIM);
		setLayout(new FillLayout(SWT.HORIZONTAL));

		String url = "https://www.facebook.com/dialog/oauth?client_id=112561958857640&redirect_uri=http://dyswis-sns.appspot.com/&response_type=token&scope=read_stream";
		//String url = "http://apps.facebook.com/dyswis-sns/";

		browser = new Browser(this, SWT.NONE);
		browser.setJavascriptEnabled(true);
		browser.setUrl(url);
		//		formToolkit.adapt(browser);
		//		formToolkit.paintBordersFor(browser);

		browser.addKeyListener(new KeyboardListener());

		browser.addLocationListener(new LocationListener() {
			@Override
			public void changing(LocationEvent event) {
			}

			@Override
			public void changed(LocationEvent event) {

				
				/*
				 * if successfully logged in
				 * 
				 * use gui less browser to log in and run the webapp
				 */
//				System.out.println(event.location);
				if (event.location.contains("http://apps.facebook.com/dyswis-sns/") ||
						event.location.contains("http://dyswis-sns.appspot.com/")) {

					if (login && doIt == false) {
						doIt = true;
						System.out.println("doit");

						crawler.logIn(email, pass);
						String data = crawler.crawlData();

						try {
							FileWriter f = new FileWriter("tt.txt");
							
							f.write(data);
							f.close();
							System.out.println(data);
						} catch (Exception e) {

						}
						System.exit(0);

					}
				}

			}


		});

		createContents();
	}

	/**
	 * Create contents of the shell.
	 */
	protected void createContents() {
		setText("DYSWIS SNS");
		setSize(1200, 800);
		setLocation(200, 100);

	}

	@Override
	protected void checkSubclass() {
		// Disable the check that prevents subclassing of SWT components
	}

	class KeyboardListener implements KeyListener {

		@Override
		public void keyPressed(KeyEvent e) {


			/*
			 * if user press enter, we can assume he tried to log in
			 * get id, pass and run the head less browser to get Hash values
			 */
			if (e.character == 13 && email == null && pass == null) {
				String emailQuery = "return document.getElementById('email').value";

				email = (String)browser.evaluate(emailQuery);

				String passQuery = "return document.getElementById('pass').value";


				pass = (String)browser.evaluate(passQuery);
				
				if (email != null && pass != null)
				login = true;
				


			}

		}

		@Override
		public void keyReleased(KeyEvent e) {
		}

	}

}