package cc.shared;



public class FacebookUtil {
    private static final String API_KEY = "xxx";
    private static final String SECRET = "47f6b800b337087937e48a11926df609";
    private static final String APPLICATION_ID = "112561958857640";

    private static final String FB_O_URL = "https://www.facebook.com/dialog/";
    private static final String FB_GRAPH_URL = "https://graph.facebook.com/";
    private static final String FB_OAUTH_URL = FB_GRAPH_URL + "oauth/";
    private static final String FB_FRIENDS_URL = FB_GRAPH_URL + "me/friends?";
    private static final String FB_POSTSS_URL = FB_GRAPH_URL + "me/posts?";
    
    // private static final String REDIRECT_URL =
    // "http://apps.facebook.com/famousity/";

    // localhost is for testing
    private static final String REDIRECT_URL = "https://apps.facebook.com/dyswis-sns/";

    public static String getApplicationId() {
        return APPLICATION_ID;
    }

    public static String getAPIKey() {
        return API_KEY;
    }

    public static String getSecret() {
        return SECRET;
    }

    public static String getAuthorizeUrl() {
        final StringBuilder sb = new StringBuilder(FB_O_URL);
        sb.append("oauth?client_id=").append(APPLICATION_ID);
        sb.append("&redirect_uri=").append(REDIRECT_URL);
        sb.append("&scope=user_status,read_stream");
        return sb.toString();
    }

    public static String getAccessTokenUrl(final String authCode) {
        final StringBuilder sb = new StringBuilder(FB_OAUTH_URL);
        sb.append("access_token?canvas=1&fbconnect=0&type=user_agent&client_id=").append(APPLICATION_ID);
        sb.append("&redirect_uri=").append(REDIRECT_URL);
//        sb.append("&client_secret=").append(SECRET);
        sb.append("&code=").append(authCode);
        System.out.println(sb.toString());
        System.out.println(getAuthorizeUrl());
        return sb.toString();
    }

    public static String getFriendsUrl(final String authToken) {
        return FB_FRIENDS_URL + authToken;
    }
    
    public static String getPostsUrl(final String authToken) {
    	return FB_POSTSS_URL + authToken;
    }
}