package edu.columbia.cs.dyswis.core.communicate.social;

import java.io.BufferedReader;
import java.io.DataInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.InputStreamReader;
import java.util.HashSet;
import java.util.Iterator;
import java.util.Set;

import org.eclipse.swt.widgets.Display;

import edu.columbia.cs.dyswis.common.baseclass.DysNode;
import edu.columbia.cs.dyswis.common.util.Functions;
import edu.columbia.cs.dyswis.core.DysCore;

public class SocialNetwork implements SocialNetworkInterface{

	public SocialNetwork(){

		//		setMyHash("ASDFK1123ASDFSDFSF");
		//		String friend = getFriendIPAddress("ASDFK1123ASDFSDFSF");
		//		addSNSPeer(friend);
		//		
		//		JFrame f = new JFrame("DYSWIS - Facebook");
		//	    f.setSize(600, 400);
		//	    f.setLocation(300,200);
		//	    f.setVisible(true);


		try {
			
			//remove tt.txt
			try {
				File f = new File("tt.txt");
				f.delete();
			} catch(Exception e){
				
			}
			
			Process p = Runtime.getRuntime().exec("java -XstartOnFirstThread -jar app.jar");
			//Process p = Runtime.getRuntime().exec("./app.sh");

			String line = "";
			BufferedReader inb = new BufferedReader(
		               new InputStreamReader(p.getErrorStream()) );
		       while ((line = inb.readLine()) != null) {
		         System.out.println(line);
		       }
		       inb.close();
			//p.waitFor();
			
		     
		     
		     boolean exists = false;
		     while (!exists){
		    	 Thread.sleep(500);
		    	 File file=new File("tt.txt");
		    	 exists = file.exists();
		     }
			
			FileInputStream fstream = new FileInputStream("tt.txt");
			// Get the object of DataInputStream
			DataInputStream in = new DataInputStream(fstream);
			BufferedReader br = new BufferedReader(new InputStreamReader(in));
			String strLine;
			//Read File Line By Line
			boolean first = false;
			while ((strLine = br.readLine()) != null)   {
				// Print the content on the console
				System.out.println(strLine);
				if (first == false) {
					setMyHash(strLine);
					System.out.println("My hash="+strLine);
					first = true;
					
					//debug: set my IP as Friend... 
					String result = getFriendIPAddress(strLine);
					if (result!=null)
						addSNSPeer(result);
				}
				else {
					String result = getFriendIPAddress(strLine);
					System.out.println("Friend hash="+strLine);
					System.out.println("Friend IP Address="+result);
					if (result!=null)
						addSNSPeer(result);
//					System.out.println
				}
				
			}
		} catch (Exception e) {
				e.printStackTrace();
		}


	}

	public boolean setMyHash(String hash) {
		String myValue = Functions.getMyIPAddress()+":"+DysCore.distributionServerPort;
		return DysCore.communicateInstance.insertValue(hash, myValue);
	}

	public String getFriendIPAddress(String hash) {
		Set set = DysCore.communicateInstance.getValue(hash);
		Iterator it = set.iterator();
		while(it.hasNext()){
			String tmp = (String)it.next();
			return tmp;
		}
		return null;

	}

	public void addSNSPeer(String address) {
		
		if (address == null) return;
		HashSet set;
		DysNode node = new DysNode();
		node.setLastConnected(System.currentTimeMillis());
		String tmp[] = address.split(":");
		if (tmp.length>1){
			node.setAddress(tmp[0]);
			node.setPort(Integer.parseInt(tmp[1]));
		}
		set = (HashSet)DysCore.communicateInstance.getPublicNodePool().get("Facebook");
		if (set==null){
			set = new HashSet();
			set.add(node);
		} else {
			set.add(node);
		}
		DysCore.communicateInstance.getPublicNodePool().put("Facebook", set);
	}

}
